function h = BC_h
% Suspension Spring-damper
    BC_global
    d = r_P{7} - r_P0{3}; d_d = r_P_d{7};
    f_sda = pp_sda(d, d_d, k(1), L_0(1), d_c(1), 0);
    f_sd_1 = -f_sda;
% Tire spring damper
    r_C = r_P{8}; r_C_d = r_P_d{8}; r_H = r_P0{4};
    f_tire = BC_radial(r_C(2), r_C_d(2), r_H(2), k(2), L_0(2), d_c(2));
    f_sd_2 = f_tire; n_sd_2 = s_rot(s_P{8})'*f_sd_2;
% Gravitational force
    w = g*m;
% Force array
    h_1 = [0; -w(1); 0] + [f_sd_1; 0];
    h_2 = [0; -w(2); 0]; h_3 = [0; -w(3); 0]; 
    h_2 = h_2 + [f_sd_2; n_sd_2]; % Tire contribution
    h = [h_1; h_2; h_3];