function z_d = BC_eqsmo(t, z)
    BC_global
    time = t;
% Unpack z into coordinate and velocity sub-arrays
    c = z(1:nbc); c_d = z(nbc+1:2*nbc);
% Transfer c and c_d to r, phi, r_d, and phi_d
    BC_c_to_r; BC_cd_to_rd;
% Compute A matrices, s_P, r_P, s_P_d and r_P_d vectors
    BC_A_matrices; BC_vectors; BC_vectors_d;
% Evaluate Jacobian and r-h-s array of accelerations
    D = BC_jacob; gamma = BC_gamma;
    
    % Stabilization feedback terms
    %     if alfa > 0.01
    %         Phi = BC_Phi; Phi_d = D*c_d;
    %         gamma = gamma - 2*alfa*Phi_d - betas*Phi;
    %     end
    
% Evaluate array of forces 
    h = BC_h;
% Solve for accelerations and Lagrange multipliers
    DMinv = D*M_inv_diag;
    Lambda = (DMinv*D')\(gamma - DMinv*h);
    c_dd = M_inv_array.*(h + D'*Lambda);
% Pack velocities and accelerations into z_d
    z_d = [c_d; c_dd];