function coords = Newton_Raphson(q, n, tol, iter_max, fun)
% Newton-Raphson process
    coords = zeros(iter_max, n+1); % space to save iteration results
    flag=0;
for i = 1:iter_max
    % Constraints and Jacobian 
        [Phi, D] = fun(q);
    % Are the constraints violated?
        ff=sqrt(Phi'*Phi);
        coords(i,:) = [ff  q']; % save the violation and coordinates
    if ff < tol
        flag=1;
        break
    end
    % Solve for corrections
        delta_q = -D\Phi;
    % Correct estimates
        q = q + delta_q;
end
if flag == 0
    'Convergence failed in Newton-Raphson'
    return
end
