% file name:  BC_formulation
% Body coordinate formulation
    clear all
    addpath Basics  BC_Basics  BC_AA
    BC_global
    BC_condata         % Constant data
    BC_vardata         % Variable data
% Determine components of vectors on the ground
    BC_vectors0;
% Transfer r, phi, r_d, and phi_d to c and c_d
    c   = BC_r_to_c(r, phi, nb);
    c_d = BC_r_to_c(r_d, phi_d, nb);
% Compute A matrices, s_P and r_P vectors
    BC_A_matrices; BC_vectors;
% Evaluate position constraints and Jacobian
    Phi = BC_Phi; D = BC_jacob;
% Evaluate velocity vectors: s_P_d and r_P_d
    BC_vectors_d;
% Evaluate r-h-s array of acceleration constraints
    gamma = BC_gamma;
% Construct diagonal mass matrix and array of forces
    BC_mass_diagonal; M_diag = diag(M_array);
    h = BC_h;
