% file name:  BC_forward
% Forward dynamic analysis: Body coordinate formulation
    clear all
    addpath Basics  BC_Basics  BC_Analyses
    folder = input(' which folder ? ', 's'); addpath (folder)
    BC_global
    BC_condata; BC_vardata; nbc = 3*nb;
% Determine components of vectors on the ground
    BC_vectors0;
% Transfer r, phi, r_d, and phi_d to c and c_d
    c   = BC_r_to_c(r, phi, nb);
    c_d = BC_r_to_c(r_d, phi_d, nb);
% Construct diagonal mass matrix
    BC_mass_diagonal; M_inv_diag = diag(M_inv_array);
% Initialize z array 
    z = [c; c_d];
% Establish time parameters
    time = 0.0;
    period = input(' time period ? '); time_end = time + period;
    delta_t = input(' delta_t ? ');
    Tspan = [time:delta_t:time_end];
    
% Enter values for the stabilization terms (Section 13.6.1)
%    alfa = input(' alpha ? '); betas = alfa^2;
    
% Begin integration

% Start simulation time clock
%    t0_clock = clock;

% options = odeset('RelTol', 1e-6, 'AbsTol', 1e-9);
%    [T, zT] = ode45(@BC_eqsmo, Tspan, z, options);

    [T, zT] = ode45(@BC_eqsmo, Tspan, z);
    
% Re-compute and save accelerations, Lagrange multipliers, etc.
    nT = size(T); zT_d = zeros(nT(1),(2*nbc-ndof));
    for i=1:nT(1)
    % Unpack zT into c and c_d arrays
        z_d = BC_eqsmo(T(i), zT(i,:)');
    % Pack c_dd and Lagrange multipliers into zT_d
        zT_d(i,:) = [z_d(nbc+1:2*nbc)' Lambda'];
    end
