% file name:  BC_ic_correct
% Initial conditions correction: Body coordinate formulation
    clear all
    addpath Basics  BC_Basics  BC_Analyses
    folder = input(' which folder ? ', 's'); addpath (folder)
    BC_global
    BC_condata; BC_vardata;
    nbc = 3*nb;
% Determine components of vectors on the ground
    BC_vectors0; 
% Parameters for kinematic analysis
    BC_parameters; n_steps = 1;
% Transfer r and phi to c; r_d and phi_d to c_d
    c = BC_r_to_c(r, phi, nb); c_d = BC_r_to_c(r_d, phi_d, nb);
    c_estimate = c;
% Ask for the method
    i_method = input(' Method 1, 2, or 3? ');
    if i_method == 1
        i_coord = input(' Cordinate number to remain unchanged? ');
        D_driver = zeros(1, nbc); D_driver(i_coord) = 1;
        rhsv = zeros(nbc,1); rhsv(nbc) = c_d(i_coord);
    end
% Coordinate correction
    flag=0;
for n = 1:NR_iter
    % Compute A matrices, vectors, constraints and Jacobian
        BC_A_matrices; BC_vectors; Phi = BC_Phi; D = BC_jacob;
    % Are the constraints violated?
        ff=sqrt(Phi'*Phi);
    if ff < NR_tol
        flag=1; break
    end
    % Solve for corrections
    if i_method == 1
        D_all = [D; D_driver]; Phi_all = [Phi; 0];
        delta_c = -D_all\Phi_all;
    elseif i_method == 2
        delta_c = -D\Phi;
    else
        delta_c = -D'*((D*D')\Phi);
    end
    % Correct estimates
        c = c + delta_c; BC_c_to_r;
end
if flag == 0
    error('Convergence failed in Newton-Raphson');
end

% Velocity correction
    if i_method == 1
        c_d = D_all\rhsv;
    elseif i_method == 2
        Phi_d = D*c_d; c_d = c_d - D\Phi_d;
    else
        c_d = c_d - D'*((D*D')\(D*c_d));
    end
