% file name:  BC_inverse
% Inverse dynamic analysis with body coordinate formulation
    clear all
    addpath Basics  BC_Basics  BC_Analyses
    folder = input(' which folder ? ', 's'); addpath (folder)
    BC_global
    BC_condata; BC_vardata; nbc = 3*nb;
% Determine components of vectors on the ground
    BC_vectors0; 
% Transfer r, phi, r_d, and phi_d to c and c_d
    c   = BC_r_to_c(r, phi, nb);
% Parameters for kinematic analysis
    BC_parameters;
% Arrays for the r-h-s of velocity constraints and to save results
    rhsv_all = zeros(nbc, 1); record = zeros(n_steps, 20);
% Construct diagonal mass matrix
    BC_mass_diagonal; % M_diag = diag(M_array);
% Ask user for the type of solution?
    sol = input(' enter 1 if power equation, 2 otherwise: ');
% Kinematic loop
    for n = 1:n_steps
    % Compute (correct) coordinates    
        coords = Newton_Raphson(c, nbc, NR_tol, NR_iter, @BC_function);
    % Compute velocities
        rhsv_all(nbc) = rhsv_driver; c_d = D_all\rhsv_all;
    % Update velocity vectors r_d, phi_d, s_P_d and r_P_d
        BC_cd_to_rd; BC_vectors_d;
    % Construct gamma array then compute accelerations
        rhsa_all = [BC_gamma; rhsa_driver]; c_dd = D_all\rhsa_all;
    % Evaluate array of forces 
        h = BC_h;
    % Method of solution?
        if sol == 1
        % Power equation
            Lambda_dr = (c_d'*(M_array.*c_dd - h))/(D_driver*c_d);
        else
        % Standard method
            Lambda = D_all'\(M_array.*c_dd - h);
            Lambda_dr = Lambda(nbc);
        end
    % Save results
        BC_inv_record;
    % Increment time
        time = time + delta_t;
    end
