function f_sda = pp_sda(d, d_d, k, L_0, d_c, f_a)
% This function computes the force of a point-to-point combined spring-
%    damper-actuator element along vector d
% Compute length of d and unit vector u
    L = sqrt(d'*d);
    u = d/L;
% Compute L_d
    L_d = d'*d_d/L;
% Compute spring and damper forces
    f_s = k*(L - L_0);
    f_d = d_c*L_d;
% Compute the sum of forces
    f = f_s + f_d + f_a;
% Compute the vector force along u
    f_sda =  f * u;
