function z_d = JC_eqsmo(t, z)
% Coordinate transformation and B matrix
    BC_global
    time = t;
% Unpack z into joint coordinate and velocity sub-arrays
    theta = z(1:njc); theta_d = z(njc+1:2*njc);
% Coordinates, vectors, and B matrix
    JC_coord_trans; BC_vectors; B = JC_Bmatrix;
% Velocity transformation; vectors r_P_d and s_P_d; B_d*theta_d array
    c_d = B*theta_d; BC_cd_to_rd; BC_vectors_d; BdThetad = JC_BdThetad;
% Mass matrix and  array of forces in body coordinates
    M_diag = diag(M_array); h = BC_h;
% Mass matrix and array of forces in joint coordinates
    M_joint = B'*M_diag*B; h_joint = B'*(h - M_array.*BdThetad);
% Solve for accelerations and Lagrange multipliers    
if nPhi_cut > 0
% Closed-chain
    D_cut = JC_jacob; gamma_cut = JC_gamma; % Cut-joints
    % Stabilization feedback terms
%     if alfa > 0.01
%         Phi_cut = JC_Phi; Phi_cut_d = D_cut*theta_d;
%         gamma_cut = gamma_cut - 2*alfa*Phi_cut_d - betas*Phi_cut;
%    end
    Minv = inv(M_joint); DMinv = D_cut*Minv;
    Lambda = (DMinv*D_cut')\(gamma_cut - DMinv*h_joint);
    theta_dd = Minv*(h_joint + D_cut'*Lambda);
else
% Open-chain
    theta_dd = M_joint\h_joint;
end
% Pack velocities and accelerations into z_d
    z_d = [theta_d; theta_dd];