function h = BC_h
% Rotational spring-damper
    BC_global
    Theta = phi(1); n_r = k(1)*(Theta - L_0(1));
    n_rsd_1 = -n_r;
% Point-to-point spring-damper
    d = r{2} - r{1}; d_d = r_d{2} - r_d{1};
    f_sda = pp_sda(d, d_d, k(2), L_0(2), d_c(2), 0);
    f_sd_1 = f_sda; f_sd_2 = -f_sda;
% Gravitational force
    w = g*m;
% Force array
    h_1 = [0; -w(1); n_rsd_1] + [f_sd_1; 0];
    h_2 = [0; -w(2); 0] + [f_sd_2; 0];
    h = [h_1; h_2];