% file name:  JC_formulation
% Joint coordinate
    clear all
    addpath Basics  BC_Basics  JC_VLP
    BC_global
    BC_condata; JC_vardata;
% Determine components of vectors on the ground
    BC_vectors0;
% Coordinate transformation
    JC_coord_trans; BC_vectors;
% B matrix
    B = JC_Bmatrix;
% Velocity transformation; vectors r_P_d and s_P_d
    c_d = B*theta_d; BC_cd_to_rd; BC_vectors_d;
% B_d*theta-d array
    BdThetad = JC_BdThetad;
    
    njc = nb; nPhi_cut = njc - ndof;    
    if nPhi_cut > 0
    % Cut-joint constraints, D matrix, gamma array
        Phi_cut = JC_Phi; D_cut = JC_jacob; gamma_cut = JC_gamma;
    end

% Mass matrix and the array of forces in body coordinates
    BC_mass_diagonal; M_diag = diag(M_array); h = BC_h;
% Mass matrix and the array of forces in joint coordinates
    M_joint = B'*M_diag*B;
    h_joint = B'*(h - M_array.*BdThetad);
