% file name:  JC_forward
% Forward dynamic analysis: Joint coordinate formulation
    clear all
    addpath Basics  BC_Basics  JC_Analyses
    folder = input(' which folder ? ', 's'); addpath (folder)
    BC_global
    BC_condata; JC_vardata;
    nbc = 3*nb; njc = nb; nPhi_cut = njc - ndof;
% Determine components of vectors on the ground
    BC_vectors0;
% Initialize z array 
    z = [theta; theta_d];
% Construct inverse of diagonal mass matrix
    BC_mass_diagonal; M_inv_diag = diag(M_inv_array);
% Establish time parameters
    time = 0.0;
    period = input(' time period ? '); time_end = time + period;
    delta_t = input(' delta_t ? ');
    Tspan = [time:delta_t:time_end];
    
% Enter values for the stabilization terms
%    alfa = input(' alpha ? '); betas = alfa^2;

% Begin integration
    [T, zT] = ode45(@JC_eqsmo, Tspan, z);
    
% Re-compute and save accelerations, Lagrange multipliers, etc.
    nT = size(T); zT_d = zeros(nT(1),(njc+nPhi_cut));
    for i=1:nT(1)
    % Unpack zT into theta and theta_d arrays
        theta = zT(i,1:njc)'; theta_d = zT(i,njc+1:2*njc)';
        z_d = JC_eqsmo(T(i), zT(i,:)');
    % Pack theta_dd and Lagrange multipliers into zT_d
        if nPhi_cut > 0
            zT_d(i,:) = [z_d(njc+1:2*njc)' Lambda'];
        else
            zT_d(i,:) = [z_d(njc+1:2*njc)'];
        end
    end
    