% file name:  JC_inverse
% Inverse dynamic analysis with joint coordinate formulation
    clear all
    addpath Basics  BC_Basics  JC_Analyses
    folder = input(' which folder ? ', 's'); addpath (folder)
    BC_global
    BC_condata; JC_vardata;
    nbc = 3*nb; njc = nb; nPhi_cut = njc - ndof;
% Determine components of vectors on the ground
    BC_vectors0;
% Parameters for kinematic analysis
    BC_parameters;
% Arrays for the r-h-s of velocity constraints and to save results
    rhsv_all = zeros(njc, 1); record = zeros(n_steps, 20);    
% Ask user for the type of solution?
    sol = input(' enter 1 if power equation, 2 otherwise: ');
% Kinematic loop
    for n = 1:n_steps
    % Compute (correct) coordinates    
        coords = Newton_Raphson(theta, njc, NR_tol, NR_iter, @JC_function);
    % Compute velocities
        rhsv_all(njc) = rhsv_driver; theta_d = D_all\rhsv_all;
    % Update velocity vectors r_d, phi_d, s_P_d and r_P_d
        B = JC_Bmatrix; c_d = B*theta_d; BC_cd_to_rd; BC_vectors_d;
    % Construct gamma array the compute accelerations
        rhsa_all = [JC_gamma; rhsa_driver]; theta_dd = D_all\rhsa_all;
    % B_d*theta-d array
        BdThetad = JC_BdThetad;
    if nPhi_cut > 0
        % Cut-joint constraints, D matrix, gamma array
            Phi_cut = JC_Phi; D_cut = JC_jacob; gamma_cut = JC_gamma;
    end
    % Mass matrix and the array of forces in body coordinates
        BC_mass_diagonal; M_diag = diag(M_array); h = BC_h;
    % Mass matrix and the array of forces in joint coordinates
        M_joint = B'*M_diag*B; h_joint = B'*(h - M_array.*BdThetad);
    % Method of solution?
        if sol == 1
        % Power equation
            Lambda = (theta_d'*(M_joint*theta_dd - h_joint)) ...
                /(D_driver*theta_d);
        else
        % Standard method
            Lambda = D_all'\(M_joint*theta_dd - h_joint);
        end
    % Save the results
        JC_inv_record;
    % Increment time
        time = time + delta_t;
    end