function h = PC_AA_h(d_EF, d_EF_d, m_A, m_B, m_C, g, ...
                     k, L_0, d_c, alpha_A)
% Compute spring-damper force
    f_sda = pp_sda(d_EF, d_EF_d, k, L_0, d_c, 0);
% Distribute the spring-damper force from E to B and Q
    f_sda_E = -f_sda;
    f_sda_A = alpha_A * f_sda_E;
% Construct gravitational vector of forces
    f_g_A = [0; -m_A*g];
    f_g_B = [0; -m_B*g];
    f_g_C = [0; -m_C*g];
% Construct array of forces
    h = [(f_sda_A + f_g_A); f_g_B; f_g_C];