function M_exact = PC_mass_3_exact(m_ps)
% Construct the exact mass matrix for a plate as three particles
    m_ijk = m_ps(1) + m_ps(2) + m_ps(3);
    mu_i = m_ps(1)/m_ijk; mu_j = m_ps(2)/m_ijk; mu_k = m_ps(3)/m_ijk;
    mii = (m_ps(1) + m_ps(4)*mu_i^2)*eye(2);
    mjj = (m_ps(2) + m_ps(4)*mu_j^2)*eye(2);
    mkk = (m_ps(3) + m_ps(4)*mu_k^2)*eye(2);
    mij = m_ps(4)*mu_i*mu_j*eye(2);
    mik = m_ps(4)*mu_i*mu_k*eye(2);
    mjk = m_ps(4)*mu_j*mu_k*eye(2);
    M_exact = [ mii   mij   mik
                mij   mjj   mjk
                mik   mjk   mkk ];
