% file name:  PC_FS_A.m
% Film Strip Advancer
    clear all
    addpath Basics  PC_Basics  PC_AA
% Constant geometric data
    r_O = [0; 0]; r_Q = [3.0; -4.5];
    L_AQ = 1.5; L_BA = 5.0; L_BO = 3.0; L_CA = 10.5119; L_CB = 5.5227;
        els = [L_AQ  L_BA  L_BO  L_CA  L_CB];
% Coordinates
    r_A = [3.963; -3.35]; r_B = [2.61; 1.45]; r_C = [0.81; 6.671];
%    r_A = [4.29; -3.750]; r_B = [2.819; 1.026]; r_C = [0.713; 6.131];
% Velocities
    r_A_d = [-11; 24]; r_B_d = [-8; 25]; r_C_d = [-4; 26];    
%    r_A_d = [141.37; -244.85]; r_B_d = [94.41; -259.40]; 
%    r_C_d = [44.21; -280.11];    
% Compute position vectors
    d_AQ = r_A - r_Q; d_BA = r_B - r_A; d_BO = r_B - r_O;
    d_CA = r_C - r_A; d_CB = r_C - r_B;
        dees = [d_AQ d_BA d_BO d_CA d_CB];
% Evaluate constraints
    Phi = PC_AA_Phi(dees, els);
% Evaluate Jacobisn
    D = PC_AA_jacob(dees);
% Compute velocity vectors
    d_AQ_d = r_A_d; d_BA_d = r_B_d - r_A_d; d_BO_d = r_B_d;
    d_CA_d = r_C_d - r_A_d; d_CB_d = r_C_d - r_B_d;
        dees_d = [d_AQ_d d_BA_d d_BO_d d_CA_d d_CB_d];
% Construct r-h-s array of acceleration constraints
    gamma = PC_AA_gamma(dees_d);
